; 
    include \masm32\include\masm32rt.inc
; 

comment * -----------------------------------------------------
                        Build this  template with
                       "CONSOLE ASSEMBLE AND LINK"

        ArgByNumber supports 2 modes of operation.

        1.  Single argument mode
            --------------------
            With this mode, the argument required should be specified
            and the "npos" parameter should be set to ZERO.

        2.  Streaming argument mode
            -----------------------
            In streaming mode the required argument should be specified
            as one (1), the variable for the "npos" argument should be
            set to ZERO and the return value in EAX should be copied
            back to the "npos" variable for the next iteration.

        ----------------------------------------------------- *

    ArgByNumber PROTO :DWORD,:DWORD,:DWORD,:DWORD

    .code

start:
   
; 

    call main
    ;; inkey
    exit

; 

main proc

    LOCAL pstr  :DWORD
    LOCAL pbuf  :DWORD
    LOCAL npos  :DWORD
    LOCAL pfile :DWORD
    LOCAL buffer[128]:BYTE

    push esi

    mov pstr, chr$("  This   is     a ",34,"multi word test",34,"     of the ArgByNumber procedure    ")

    print pstr,13,10

    mov pbuf, ptr$(buffer)
    mov esi, 1                              ; use ESI as arg counter

  ; --------------------------------
  ; incremented single argument mode
  ; --------------------------------
  @@:
    invoke ArgByNumber,pstr,pbuf,esi,0
    mov eax, pbuf
    cmp BYTE PTR [eax], 0                   ; test if destination buffer is empty
    je @F
    print pbuf,13,10
    add esi, 1
    jmp @B
  @@:

  ; --------------
  ; streaming mode
  ; --------------
    mov pfile, InputFile("\masm32\include\windows.inc")
    mov npos, 0
  @@:
    mov npos, rv(ArgByNumber,pfile,pbuf,1,npos)
    mov eax, pbuf
    cmp BYTE PTR [eax], 0                   ; test if destination buffer is empty
    je @F
    print pbuf,13,10
    add esi, 1
    jmp @B
  @@:

    free pfile

    pop esi

    ret

main endp


; 

    .data

    align 4
    abntbl \
      db 2,0,0,0,0,0,0,0,0,1,1,0,0,1,0,0
      db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
      db 1,0,3,0,0,0,0,0,0,0,0,0,1,0,0,0
      db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
      db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
      db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
      db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
      db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
      db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
      db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
      db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
      db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
      db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
      db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
      db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
      db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1

    ; 0 = OK char
    ; 1 = delimiting characters   tab LF CR space "," & > ASCII 127
    ;
    ; 2 = ASCII zero    This should not be changed in the table
    ; 3 = quotation     This should not be changed in the table

; 

    .code

align 4

ArgByNumber proc src:DWORD,dst:DWORD,num:DWORD,npos:DWORD

comment * ------------------------------------------------------

        ArgByNumber copies a user specified delimited argument
        from within the supplied source to a user specified
        buffer. Quoted text is supported as a single argument.

        src     The source to get the argument from
        dst     The destination buffer for the result
        num     A one (1) based argument number.
        npos    The OFFSET to start from in the source

        1 = argument 1
        2 = argument 2 etc ...

        Return value in EAX
        -------------------
        The next read position in the source buffer

        Return values in ECX
        --------------------
        1 = successful operation
        2 = no argument exists at specified arg number
        3 = non matching quotation marks

        Determining if there are no more arguments
        ------------------------------------------
        You can test the first byte of the destination buffer
        for ZERO to determine if there are more arguments in
        the source.

        ------------------------------------------------------ *

    push ebx
    push esi
    push edi

    mov esi, src
    add esi, npos
    mov edi, dst

    mov BYTE PTR [edi], 0           ; set destination buffer to zero length

    xor ebx, ebx

  ; *********
  ; scan args
  ; *********
  bcscan:
    movzx eax, BYTE PTR [esi]
    add esi, 1
    cmp BYTE PTR [abntbl+eax], 1    ; delimiting character
    je bcscan
    cmp BYTE PTR [abntbl+eax], 2    ; ASCII zero
    je quit

    sub esi, 1
    add ebx, 1
    cmp ebx, num                    ; copy next argument if number matches
    je cparg

  gcscan:
    movzx eax, BYTE PTR [esi]
    add esi, 1
    cmp BYTE PTR [abntbl+eax], 0    ; OK character
    je gcscan
    cmp BYTE PTR [abntbl+eax], 2    ; ASCII zero
    je quit
    cmp BYTE PTR [abntbl+eax], 3    ; quotation
    je dblquote

    jmp bcscan                      ; return to delimiters

  dblquote:
    add esi, 1
    cmp BYTE PTR [esi], 0
    je qterror
    cmp BYTE PTR [esi], 34
    jne dblquote

    add esi, 1
    jmp bcscan                      ; return to delimiters

  ; ********
  ; copy arg
  ; ********
  cparg:
    xor eax, eax
    xor edx, edx
    cmp BYTE PTR [esi+edx], 34      ; if 1st char is a quote
    je cpquote                      ; jump to quote copy
  @@:
    mov al, [esi+edx]               ; copy normal argument to buffer
    mov [edi+edx], al
    add edx, 1
    cmp BYTE PTR [abntbl+eax], 1
    jl @B
    mov BYTE PTR [edi+edx], 0       ; append terminator
    jmp quit

  cpquote:
    add esi, 1
  @@:
    mov al, [esi+edx]               ; strip quotes and copy contents to buffer
    test al, al
    jz qterror
    cmp al, 34
    je write_zero
    mov [edi+edx], al
    add edx, 1
    jmp @B

  write_zero:
    add edx, 1                      ; correct EDX for final exit position
    mov BYTE PTR [edi+edx-1], 0     ; append terminator
    jmp quit

  qterror:
    mov ecx, 3                      ; quotation error
    jmp TheEnd

  quit:
    mov ecx, 1                      ; successful operation = 1
    cmp BYTE PTR [edi], 0
    jne TheEnd
    mov ecx, 2                      ; no argument at user specified number

  TheEnd:

  ; -----------------------------------------------------
  ; calculate the next read position and return it in EAX
  ; -----------------------------------------------------
    mov eax, esi
    add eax, edx
    sub eax, src

    pop edi
    pop esi
    pop ebx

    ret

ArgByNumber endp

; 

end start